<?

/*******************************************************************

 XdN Counter

 http://xenomorph.net/programming/php/

 Updates:

 Oct 24th - Self dicovery of $filename.

 Nov 7th - change color/size thing (!$color became $color < " " to make sure it wasnt set)
 + removed attempt of changing access to $path

 Dec 14th - added Default settings, changed flock from '1' to '2'

*******************************************************************/


function do_counter($size, $color)
{

// --- Default Settings ---->

$default_size	= "2";						// default font size
$default_color	= "black";					// default font color

// -------------------------

$filename = $_SERVER['PHP_SELF'];				// file name is the same as script running this
// echo "<br> $filename <br>";					// (debug)

$filename = basename($filename);        			// just the file name without path info
// echo "<br> $filename <br>";					// (debug)

if (!$filename) { $filename = "index.php"; }			// if there is no filename, then we're
$filename = $filename . ".counter";				// viewing "index.php" - so make that the file name
// echo "<br><br>File Name: <b>$filename</b><br>";		// (debug)

$counter_dir	=	"_counters"; 				// set Counter directory
// echo "Counter Dir: $counter_dir <br>";			// (debug)

$path = dirname(realpath($_SERVER['SCRIPT_FILENAME']));		// find the path

// Convert path to Unix style if on a Windows system. ("\" to "/")
$path = ereg_replace("[\\]", "/", "$path");
//echo "Path: $path <br>";					// (debug)

//chmod("$path", 0777);				// attempt to Set path to 777
						// so subdirectories can be made
$path = $path . "/";				// add a "/" after path name
// echo "Path: $path <br>";			// (debug)

$counter_path = $path . $counter_dir ;		// counter path
// echo "Counter Path: $counter_path <br>";	// (debug)


if (!is_dir($counter_path)){
 mkdir("$counter_path", 0755);			// Create the directory if it doesn't exist.
 chmod("$counter_path", 0777);			// Change to 777
}

 if ($size < " ") { $size = $default_size; }	// If $size is not set, set to default
 if ($color < " ") { $color = $default_color; }	// If $color is not set, set to default

$counter_file = "$counter_path/$filename";	// set Counter File

// echo "Counter File: $counter_file <br>";

if (file_exists("$counter_path/$filename"))	// If file exists
 {
  $fp = fopen("$counter_path/$filename","r+");	// Open Read/Write, pointer at top
 }
else
 {
  $fp = fopen("$counter_path/$filename","a+");	// If not, then create file
 }
 flock($fp,2);					// Lock file
 $count = fgets($fp,15);			// get the number out
 $count += 1;					// add 1 to it
 rewind($fp);					// go to beginning of file
 fputs($fp,$count);				// type in new Counter value
 flock($fp,3);					// release Lock
 fclose($fp);					// close file
 $count = number_format($count);		// Format the counter
 echo "<font color=\"$color\" size=\"$size\">$count</font>";	// display counter
}

?>